#ifndef __NXP_FRAC_H__
#define __NXP_FRAC_H__
#include "int.h"

typedef struct _NxpElementFrac 	NxpElementFrac;

#include "element.h"

#define NXP_ELEMENT_FRAC(x)		(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_FRAC, NxpElementFrac	))
#define NXP_ELEMENT_IS_FRAC(x)	        (NXP_ELEMENT_GET_TYPE(x) == NXP_ELEMENT_TYPE_FRAC)

#define NXP_ELEMENT_FRAC_POSITIVE(x)    (NXP_ELEMENT_FRAC(x)->signal)
#define NXP_ELEMENT_FRAC_SIGNAL(x)      (NXP_ELEMENT_FRAC(x)->signal)
#define NXP_ELEMENT_FRAC_NUM(x)         (NXP_ELEMENT_FRAC(x)->numerator)
#define NXP_ELEMENT_FRAC_DENUM(x)       (NXP_ELEMENT_FRAC(x)->denumerator)
#define NXP_ELEMENT_FRAC_VALUE(x)       (NXP_ELEMENT_FRAC_POSITIVE(x)?\
                   ((nxp_real_t)NXP_ELEMENT_FRAC_NUM(x))/((nxp_real_t)NXP_ELEMENT_FRAC_DENUM(x)):\
                  -((nxp_real_t)NXP_ELEMENT_FRAC_NUM(x))/((nxp_real_t)NXP_ELEMENT_FRAC_DENUM(x)))
#define REAL(x)                         ((nxp_real_t)x)

struct _NxpElementFrac {
    NxpElement element;
    nxp_int_t numerator;
    nxp_int_t denumerator;
    gboolean signal; 		/* true: positive; false: negative */
};



void        nxp_element_frac_init           (GError         **error);
NxpElement* nxp_element_frac_new            (nxp_int_t        a,
					     nxp_int_t        b);
NxpElement* nxp_element_frac_new_with_signal(nxp_int_t        a,
					     nxp_int_t        b,
					     gboolean         c);
NxpElement* nxp_frac_simplify(NxpElementFrac* el);

#endif /* __NXP_FRAC_H__ */
