/* -*- Mode: C; c-file-style: "stroustrup"; -*- */
#ifndef __FUNCTION_H__
#define __FUNCTION_H__

typedef struct _NxpElementFunction	NxpElementFunction;
typedef struct _NxpFunctionArguments	NxpFunctionArguments;

#include "element.h"

#define NXP_ELEMENT_FUNCTION(x)	(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_FUNCTION,	NxpElementFunction	))


struct _NxpElementFunction {
    NxpElement element;
    NxpIdentifier *ident;
    NxpFunctionArguments *args;
};

struct _NxpFunctionArguments {
    GHashTable *named_args;
    GSList *simple_args;
};

void        nxp_element_function_init (GError        **error);
NxpElement* nxp_element_function_new  (NxpIdentifier  *ident,
				       NxpFunctionArguments *args);


NxpFunctionArguments* nxp_function_arguments_new(GSList *args,
						GHashTable *named);
void nxp_function_arguments_free(NxpFunctionArguments *nfa);
GHashTable *nxp_named_args_ref(GHashTable *named_args);


#endif /* __FUNCTION_H__ */
