#ifndef __VECTOR_H__
#define __VECTOR_H__

#include "int.h"
#include "element.h"

typedef struct _NxpElementVector	NxpElementVector;

#define NXP_ELEMENT_VECTOR(x)	(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_VECTOR,	NxpElementVector	))
#define NXP_ELEMENT_IS_VECTOR(x)	        (NXP_ELEMENT_GET_TYPE(x) == NXP_ELEMENT_TYPE_VECTOR)

struct _NxpElementVector {
    NxpElement   element;
    guint        size;
    NxpElement **data;
};

#define NXP_ELEMENT_VECTOR_SIZE(x)    x->size
#define NXP_ELEMENT_VECTOR_ELEM(v, pos)  ((NxpElement*)(v->data[pos]))

/* returns an lvalue of an element of the vector -- should not be used
   directly (usually); element should be an NxpElementVector*  */
#define _element_vector_index(elem, i) elem->data[i]

void        nxp_element_vector_init     (GError           **error);
NxpElement* nxp_element_vector_new      (guint              size,
					 NxpElement       **data);
NxpElement* nxp_element_vector_new_from_range(nxp_int_t low, nxp_int_t high, GError **error);
void        _element_vector_set         (NxpElementVector  *vec,
					 guint              index,
					 NxpElement        *element);
NxpElement* _element_vector_get         (NxpElementVector  *vec,
					 guint              index);
NxpElement* nxp_element_vector_real_put (NxpElementVector  *vector,
					 NxpElement        *element,
					 guint              index);
NxpElement* vector_times_scalar         (NxpElementVector  *vec,
					 NxpElement        *scalar,
					 NxpEvalContext    *context);
NxpElement* vector_times_vector         (NxpElementVector  *vec1,
					 NxpElementVector  *vec2,
					 NxpEvalContext    *context);


#endif


